#pragma once

#include <GL/glew.h>
#include <sys/types.h>

namespace buffer {
    /// Draw options
    struct params {
        /// Bind only vertices positions
        bool vertexOnly;
        size_t instances = 1;
    };

    /// Abstract OpenGL Buffer
    class Abstract {
    public:
        Abstract(GLenum shape);
        virtual ~Abstract();

        /// Bind and draw buffer
        virtual uint draw(params params) = 0;

    protected:
        GLenum Shape;

        GLuint VertexBufferID;

        void enableVertexAttrib();
        void disableVertexAttrib();
        void enableAllAttribs();
        void disableAllAttribs();

        void setVertices(const unsigned long size, const void *data);
    };
}
