#pragma once

#include <glm/glm.hpp>
#include <string.h> // for memcmp
#include <GL/glew.h>

namespace buffer {
    /// Vertex properties
    struct VertexData {
        VertexData(const glm::vec3 &position, GLushort material, const glm::vec3 &normal):
            Position(position), Material(material), Normal(normal) { }
        glm::vec3 Position;
        GLushort Material;
        glm::vec3 Normal;
        bool operator<(const VertexData that) const {
            return memcmp((void *)this, (void *)&that, sizeof(VertexData)) > 0;
        };
    };
}
