#pragma once

#include "Program.hpp"
#include "../buffer/Vertex.hpp"

namespace pass {
    /// Skybox pass
    class SkyProgram: public Program {
    public:
        SkyProgram();
        ~SkyProgram();

        std::string getName() const override;
        void start(Renderer *) override;
        buffer::params setup(Renderer *, glm::mat4 modelMatrix) override;

        /// Direct draw using internal buffer
        void draw(Renderer *);

        void setView(const GLfloat *matrix);
        void setProjection(const GLfloat *matrix);

        void bindTexture(const GLuint textureID);

    private:
        GLuint ViewMatrixID;
        GLuint ProjectionMatrixID;
        GLuint TextureID;

        buffer::Vertex CubeBuffer;
    };
}
