#pragma once

#include <array>
#include <string>

namespace world::materials {
    /// Materials count
    static const auto count = 9;
    static_assert(count < (USHRT_MAX >> 4)); //NOTE: for byte packing see Voxel
    /// Materials textures
    static const std::array<std::string, count> textures = {{"Air", "Sand", "Dirt", "Stone_path", "Mapl", "Seaside_rock", "Stone_wall", "Rough_rock", "Alien"}};
    /// Materials roughness.
    /// -1: slope, 0: normal, 1: cube
    static const std::array<float, count> roughness = {{0, 0, 0, 0, 0, 0, 0, -1, .8}};
}
